
(in-package :TRAPS)             ; ***********************************************************
; 
; Created: Sunday, June 6, 1993 at 3:00PM
;  OCEErrors.p
;  Pascal Interface to the Macintosh Libraries
; 
;   Copyright Apple Computer, Inc. 1990-1993
;   All rights reserved
; 
; ***********************************************************

; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes:= 0
; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED UsingOCEErrors
; $SETC UsingOCEErrors:= 1

; $I+
; $SETC OCEErrorsIncludes:= UsingIncludes
; $SETC UsingIncludes:= 1

; $IFC UNDEFINED UsingErrors

(require-interface 'ERRORS)     ; $I $$Shell(PInterfaces)Errors.p
; $ENDC

; $SETC UsingIncludes:= OCEErrorsIncludes

; 
; Allocated ranges:
; 	AOCE General Errors						-1500 to -1539
; 	AOCE Authentication Errors				-1540 to -1609
; 	AOCE Catalog Errors						-1610 to -1680
; 	
; 	AOCE Standard Mail Errors				-1900 to -1949
; 	AOCE Standard Catalog Errors			-1950 to -1969
; 	AOCE Digital Signature Errors			-1970 to -1999
; 
; 	AOCE Templates Errors					-15000 to -15039
; 	AOCE Mail Errors						-15040 to -15089
; 	AOCE Messaging Errors					-15090 to -15169
; 	Reserved for future						-15170 to -15199
; 

;  AOCE General Errors (-1500 to -1539) 

(defconstant $kOCEToolboxNotOpen -1500);  Toolbox not open; perhaps its closing 
(defconstant $kOCEInvalidCommand -1501);  Request code passed to a trap call is invalid 
(defconstant $kOCEInvalidRef -1502);  a reference to an object is obsolete or invalid 
(defconstant $kOCEBufferTooSmall -1503);  the buffer supplied is too small for the task 
(defconstant $kOCEVersionErr -1504);  some manner of software version mismatch 
(defconstant $kOCESyncAsyncErr -1505);  Op tried synchronously may only be done async, or vice versa 
(defconstant $kOCEInternalErr -1506);  the OCE toolbox has an internal error 
(defconstant $kOCENotAnOwner -1507);  this operation can only be done by the object's owner 
(defconstant $kOCENotImplemented -1508);  Feature not implemented 
(defconstant $kOCENotAuthenticated -1509);  The user must be authenticated 
(defconstant $kOCEAlreadyExists -1510);  The object being added already exists 
(defconstant $kOCEDoesntExist -1511);  the object being referenced doesn't exist or cannot be found 
(defconstant $kOCEConnectionErr -1512);  Unable to open or maintain a network transport 
(defconstant $kOCEConnectionClosed -1513);  Connect has closed 
(defconstant $kOCEInvalidRecipient -1514);  Invalid recipient/address for this command 
(defconstant $kOCEInvalidIndex -1515);  invalid index (out of range) 
(defconstant $kOCERefIsClosing -1516);  Object references is being closed, cannot complete command 
(defconstant $kOCEHasPendingMsgs -1517)
(defconstant $kOCEInvalidConfiguration -1518)
(defconstant $kOCERequiredServicesNotAvailable -1519)
(defconstant $kOCEServerInactive -1520)
(defconstant $kOCEMoreDiskSpaceNeeded -1521);  Inadequate disk space to safely complete operation 
(defconstant $kOCEParamErr #$PARAMERR);  invalid parameter passed to toolbox 

;  AOCE Authentication Errors (-1540 to -1609) 

(defconstant $kOCEReadAccessDenied -1540)
(defconstant $kOCEWriteAccessDenied -1541)
(defconstant $kOCEAccessRightsInsufficient -1542);  stream needs to be authenticated, or not authorized, or someone other than agent trying to TPFC, or problem in server-to-server authentication 
(defconstant $kOCEUnsupportedCredentialsVersion -1543);  don't know how to read that version of credentials 
(defconstant $kOCECredentialsProblem -1544);  couldn't successfully decrypt credentials 
(defconstant $kOCECredentialsImmature -1545);  current time < first valid time 
(defconstant $kOCECredentialsExpired -1546);  current time > expiry time 
(defconstant $kOCEProxyImmature -1547);  current time < proxy start time 
(defconstant $kOCEProxyExpired -1548);  current time > proxy expiry time 
(defconstant $kOCEDisallowedRecipient -1549);  Recipient not specified in proxy 
(defconstant $kOCENoKeyFound -1550);  found no key for entity in question 
(defconstant $kOCEPrincipalKeyNotFound -1551);  couldn't decode proxy because principal has no key 
(defconstant $kOCERecipientKeyNotFound -1552);  recipient has no key 
(defconstant $kOCEAgentKeyNotFound -1553);  in TPFC, agent has no key 
(defconstant $kOCEKeyAlreadyRegistered -1554);  entity already has a key 
(defconstant $kOCEMalformedKey -1555);  key is of an unknown encryption method, or key doesn't match password 
(defconstant $kOCEUndesirableKey -1556);  password too short, key too simple, or trying to change cluster key to the same value 
(defconstant $kOCEWrongIdentityOrKey -1557);  In CheckIdentity, name doesn't exist or key is wrong 
(defconstant $kOCEInitiatorKeyProblem -1558);  either we couldn't find the initiator's key or we found it but couldn't successfully decrypt instructions or proxy 
(defconstant $kOCEBadEncryptionMethod -1559);  the specified encryption method is not supported 
(defconstant $kOCELocalIdentityDoesNotExist -1560);  LocalIdentity has to be setup 
(defconstant $kOCELocalAuthenticationFail -1561);  LocalIdentity Login has to be done for this operation 
(defconstant $kOCELocalIdentitySetupExists -1562);  LocalIdentity setup exists, use change instead of setup 
(defconstant $kOCEDirectoryIdentitySetupExists -1563);  DirectoryIdentity setup exists, use change instead of setup 
(defconstant $kOCEDirectoryIdentitySetupDoesNotExist -1564);  DirectoryIdentity setup does not exist 
(defconstant $kOCENotLocalIdentity -1565);  Use LocalIdentity calls instead! 
(defconstant $kOCENoMoreIDs -1566);  identity table is full 
(defconstant $kOCEUnknownID -1567);  identity passed is not valid 
(defconstant $kOCEOperationDenied -1568);  LocalID operation denied 
(defconstant $kOCEAmbiguousMatches -1569);  ambiguous matches found in resolving CIDs (more than 1 CID) 
(defconstant $kOCENoASDSPWorkSpace -1570);  No ASDSP workspace passed for Open Secure Stream 
(defconstant $kOCEAuthenticationTrouble -1571);  generic authentication problem 

;  AOCE Catalog Errors (-1610 to -1680) 

(defconstant $kOCENotLocal -1610);  the server does not serve the requested dNode 
(defconstant $kOCETooBusy -1611);  server cannot complete call at this time 
(defconstant $kOCEDatabaseFull -1612);  disk is full 
(defconstant $kOCETargetDirectoryInaccessible -1613);  Catalog server not responding 
(defconstant $kOCEBogusArgs -1614);  Args not formatted correctly on the wire 
(defconstant $kOCENoSuchDNode -1615);  the requested dNode does not exist 
(defconstant $kOCEDNodeUnavailable -1616);  could not find any servers that serve the requested dNode 
(defconstant $kOCEBadRecordID -1617);  invalid RecordID (usually name and/or type don't match cid) 
(defconstant $kOCENoSuchRecord -1618);  the specified record does not exist 
(defconstant $kOCENoSuchAttributeValue -1619);  The attribute value that was passed in does not exist 
(defconstant $kOCENoSuchPseudonym -1620);  the specified pseudonym does not exist 
(defconstant $kOCEAttributeValueTooBig -1621);  self-explanatory 
(defconstant $kOCETypeExists -1622);  The type already exists in the record 
(defconstant $kOCEMoreData -1623);  only a warning - buffer not big enough 
(defconstant $kOCERefNumBad -1624);  RefNum is not valid 
(defconstant $kOCEStreamCreationErr -1625);  problem creating stream 
(defconstant $kOCEOperationNotSupported -1626);  the specified catalog does not support this operation 
(defconstant $kOCEPABNotOpen -1627);  specified Personal Catalog is not open to make the operation 
(defconstant $kOCEDSAMInstallErr -1628);  specified CSAM could not be installed 
(defconstant $kOCEDirListFullErr -1629);  catalog list is full, try removing an entry 
(defconstant $kOCEDirectoryNotFoundErr -1630);  catalog was not found in the list 
(defconstant $kOCEAbortNotSupportedForThisCall -1631);  this call cannot be aborted 
(defconstant $kOCEAborted -1632);  this call was aborted 
(defconstant $kOCEOCESetupRequired -1633);  LocalIdentity Setup is required 
(defconstant $kOCEDSAMRecordNotFound -1634);  CSAM Record not found 
(defconstant $kOCEDSAMNotInstantiated -1635);  CSAM is not instantiated 
(defconstant $kOCEDSAMRecordExists -1636);  CSAM record already exists 
(defconstant $kOCELengthError -1637);  supplied buffer was too small 
(defconstant $kOCEBadStartingRecord -1638);  Lookup starting record is not within range 
(defconstant $kOCEBadStartingAttribute -1639);  Lookup starting attribute is not within range 
(defconstant $kOCEMoreAttrValue -1640);  attribute value could not fit into buffer (even though it was the only value) 
(defconstant $kOCENoDupAllowed -1641)
(defconstant $kOCENoSuchAttributeType -1642)
(defconstant $kOCEMiscError -1643);  some other error 
(defconstant $kOCENoSuchIcon -1644);  no matching icon from GetDirectoryIcon 
(defconstant $kOCERLIsDontMatch -1645);  RLIs do not match in lookup 
(defconstant $kOCEDirectoryCorrupt -1646);  Serious disk fill corruption problem 

;  AOCE Standard Mail Errors (-1900 to -1949) 

(defconstant $kSMPNotEnoughMemoryForAllRecips -1900)
(defconstant $kSMPCopyInProgress -1901)
(defconstant $kSMPMailerNotInitialized -1902)
(defconstant $kSMPShouldNotAddContent -1903)
(defconstant $kSMPMailboxNotFound -1904)
(defconstant $kSMPNoNextLetter -1905)
(defconstant $kSMPHasOpenAttachments -1906)
(defconstant $kSMPFinderNotRunning -1907)
(defconstant $kSMPCommandDisabled -1908)
(defconstant $kSMPNoMailerInWindow -1909)
(defconstant $kSMPNoSuchAddress -1910)
(defconstant $kSMPMailerAlreadyInWindow -1911)
(defconstant $kSMPMailerUneditable -1912)
(defconstant $kSMPNoMatchingBegin -1913)
(defconstant $kSMPCannotSendReceivedLetter -1914)
(defconstant $kSMPIllegalForDraftLetter -1915)
(defconstant $kSMPMailerCannotExpandOrContract -1916)
(defconstant $kSMPMailerAlreadyExpandedOrContracted -1917)
(defconstant $kSMPIllegalComponent -1918)
(defconstant $kSMPMailerAlreadyNotTarget -1919)
(defconstant $kSMPComponentIsAlreadyTarget -1920)
(defconstant $kSMPRecordDoesNotContainAddress -1921)
(defconstant $kSMPAddressAlreadyInList -1922)
(defconstant $kSMPIllegalSendFormats -1923)
(defconstant $kSMPInvalidAddressString -1924)
(defconstant $kSMPSubjectTooBig -1925)
(defconstant $kSMPParamCountErr -1926);   enclosure count != 1, while sendEnclosure Only == true. 
(defconstant $kSMPTooManyPages -1927);   Exceeding the image page limit. 
(defconstant $kSMPTooManyEnclosures -1928)

;  AOCE Standard Catalog Errors (-1950 to -1969) 

(defconstant $kSDPNoSearchText -1950)
(defconstant $kSDPTooManyLoginAttempts -1951)
(defconstant $kSDPNoSelection -1952)
(defconstant $kSDPPersonalDirectoryRepairFailed -1953)

;  AOCE Digital Signature Errors (-1970 to -1999) 

(defconstant $kSIGOperationIncompatibleErr -1970);  context in use for different type of operation 
(defconstant $kSIGCertificateQueryDenied -1971);  can't query certificates with this context 
(defconstant $kSIGVerifyFailedErr -1972);  verification failed 
(defconstant $kSIGInvalidCredentialErr -1973);  verified OK but credential out of date,  either pending or expired 
(defconstant $kSIGIndexErr -1974);  the index given is outside the range of allowable values 
(defconstant $kSIGSignerErr -1975);  problem with the signer or signature itself 
(defconstant $kSIGPasswordErr -1976);  password is incorrect 
(defconstant $kSIGInternalsErr -1977);  an internal error occurred like a bad digest, context or signature 
(defconstant $kSIGToolboxNotPresentErr -1978);  for client services (ie servers) to report back - not retruned by the TB 
(defconstant $kSIGContextPrepareErr -1979);  context either prepared with VerifyPrepare, SignPrepare or DigestPrepare already or has been corrupted 
(defconstant $kSIGNoDigestErr -1980);  no digest in the signature 
(defconstant $kSIGConversionErr -1981);  unabled to convert an attribute to Mac format 
(defconstant $kSIGSignerNotValidErr -1982);  Signer has either expired or is pending and can not sign 
(defconstant $kSIGNoSignature -1983);  standard file signature not found 

;  AOCE Templates Errors (-15000 to -15039) 

(defconstant $kDETInvalidTargetAspectName -15000);  Could not locate an aspect by name 
(defconstant $kDETInvalidTargetItemNumber -15001);  Item number is target invalid (out of range 1..<number of children>) 
(defconstant $kDETInvalidTargetFromNonAspect -15002);  Target selection relative to non-aspect object which requires an aspect 
(defconstant $kDETInvalidTargetDSSpec -15003);  Target DSSpec could not be resolved 
(defconstant $kDETUnknownTargetSelector -15004);  Unknown selector type for target specification 
(defconstant $kDETInvalidTarget -15005);  Target specification was invalid (for reasons other than those above) 
(defconstant $kDETTargetNotAnAspect -15006);  Specified target object was not an aspect 
(defconstant $kDETInvalidCommandItemNumber -15007);  Command item number invalid (out of range 1..<number of items in selection>) 
(defconstant $kDETUnableToGetCommandItemSpec -15008);  Unable to retrieve item specification (internal error, possibly out of memory) 
(defconstant $kDETRequestedTypeUnavailable -15009);  Command item could not be represented in the form requested 
(defconstant $kDETInvalidDSSpec -15010);  Could not resolve DSSpec (other than in target; see error above for targets) 
(defconstant $kDETUnableToAccessProperty -15011);  Property could not be found and/or created 
(defconstant $kDETInfoPageNotOpen -15012);  Info-page not open; request requires an open info-page 
(defconstant $kDETNoSuchView -15013);  No view found with specified property number 
(defconstant $kDETCouldNotAddMenuItem -15014);  Could not add item to dynamic menu 
(defconstant $kDETCouldNotRemoveMenuItem -15015);  Could not remove item from dynamic menu 
(defconstant $kDETCouldNotFindMenuItem -15016);  Could not find menu item 
(defconstant $kDETCouldNotFindCustomView -15017);  Could not find custom view in info-page 
(defconstant $kDETInvalidReqFunction -15018);  Invalid call-back request function 
(defconstant $kDETInvalidCallBack -15019);  Invalid call-back (for reasons other than those above) 
(defconstant $kDETPropertyBusy -15020);  Edit is open on the property being set 

;  AOCE Mail Errors (-15040 to -15089) 

(defconstant $kMailInvalidOrder -15040);  This object has already been written to and cannot be written again 
;  handle non-zero offsets for now 
(defconstant $kMailInvalidSeqNum -15041);  Invalid letter sequence o refers to an nonexistent letter 
(defconstant $kMailAttrNotInHdr -15042);  attribute does not exist in this letter header 
(defconstant $kMailHdrAttrMissing -15043);  required attribute not written into letter header 
(defconstant $kMailBadEnclLengthErr -15044);  incorrect number of bytes has been written after memForm of PutEnclosure 
(defconstant $kMailInvalidRequest -15045);  cannot putAttr for report, putRcptReport for letter 
(defconstant $kMailInvalidPostItVersion -15046);  cannot create new postit with this version 
(defconstant $kMailNotASlotInQ -15047);  queueID does not refer to a slot's incoming queue 
(defconstant $kMailLtrNotOpen -15048);  letter is not open, probably not cached in inQ 
(defconstant $kMailMissingMailCat -15049);  trying to create message in inq, with no postIt 
(defconstant $kMailCannotWriteMailCat -15050);  cannot update a mail catentry 
(defconstant $kMailTooManyTagsPerLetter -15051);  cannot add more than kMaxTagsPerLetter tags 
(defconstant $kMailGwyDead -15052);  MSAM died 
(defconstant $kMailIgnoredErr -15053);  ePPC message was ignored 
(defconstant $kMailLengthErr -15054);  ePPC message did not complete 
(defconstant $kMailTooManyErr -15055);  Too many = request outstanding, 
(defconstant $kMailNoMSAMErr -15056);  no MSAMs found in mailbox! or for command 
(defconstant $kMailCancelled -15057)
(defconstant $kMailSlotSuspended -15058)
(defconstant $kMailMSAMSuspended -15059)
(defconstant $kMailBadSlotInfo -15060)
(defconstant $kMailMalformedContent -15061);  a mailed structure is malformed 
(defconstant $kMailNoSuchSlot -15062);  no such slot 
(defconstant $kMailBadLtrInfo -15063);  bad info there, can't change 
(defconstant $kMailSetFailed -15064);  could not set letter info 
(defconstant $kMailBadConfig -15065);  MSAM has bad config info 
(defconstant $kMailBadMSAM -15066);  bad MSAM: not usable = reason unspec, 
(defconstant $kMailCannotLkupServerSlots -15067);  cannot lookup adas for server mail slots 
(defconstant $kMailBadState -15068);  the state specifiy is not in any of defined 

;  AOCE Messaging Errors (-15090 to -15169) 

(defconstant $kIPMCantCreateIPMCatEntry -15090)
(defconstant $kIPMInvalidMsgType -15091);  bad msg hint 
(defconstant $kIPMInvalidProcHint -15092);  bad proc hint 
(defconstant $kIPMInvalidOffset -15093);  bad offset for read/write 
(defconstant $kIPMUpdateCatFailed -15094)
(defconstant $kIPMMsgTypeReserved -15095)
(defconstant $kIPMNotInABlock -15096)
(defconstant $kIPMNestedMsgOpened -15097)
(defconstant $kIPMA1HdrCorrupt -15098)
(defconstant $kIPMCorruptDataStructures -15099)
(defconstant $kIPMAbortOfNestedMsg -15100)
(defconstant $kIPMBlockIsNotNestedMsg -15101)
(defconstant $kIPMCacheFillError -15102)
(defconstant $kIPMInvalidSender -15103)
(defconstant $kIPMNoRecipientsYet -15104)
(defconstant $kIPMInvalidFilter -15105)
(defconstant $kIPMAttrNotInHdr -15106)
(defconstant $kIPMBlkNotFound -15107)
(defconstant $kIPMStreamErr -15108);  Error on stream (should this ever go out?) 
(defconstant $kIPMPortClosed -15109);  Port closed (should this ever go out?) 
(defconstant $kIPMBinBusy -15110)
(defconstant $kIPMCorruptedBin -15111)
(defconstant $kIPMBadQName -15112)
(defconstant $kIPMEndOfBin -15113)
(defconstant $kIPMBinNeedsConversion -15114)
(defconstant $kIPMMgrInternalErr -15115)
(defconstant $kIPMEltBusy -15116)
(defconstant $kIPMEltClosedNotDeleted -15117)
(defconstant $kIPMBadContext -15118)
(defconstant $kIPMContextIsClosing -15119)
(defconstant $kIPMeoQ -15120)
(defconstant $kIPMQOutOfSpace -15121)
(defconstant $kIPMEltNotFound -15122)
(defconstant $kIPMBinOutOfSpace -15123)
(defconstant $kIPMeoCatEntry -15124)
(defconstant $kIPMeoElt -15125)
(defconstant $kIPMQBusy -15126)
(defconstant $kIPMNotSameBin -15127)
(defconstant $kIPMNoMoreServices -15128)
(defconstant $kIPMLookupAttrTooBig -15129);  attribute in lookup is too big 
(defconstant $kIPMUnknownUAM -15130)
(defconstant $kIPMUnsupportedLogin -15131)
(defconstant $kIPMLogInUnknown -15132)
(defconstant $kIPMNoMoreFilters -15133)
(defconstant $kIPMCouldNotReadInfoReply -15134)
(defconstant $kIPMInvalidUser -15135)
(defconstant $kIPMNoMoreSessions -15136)
(defconstant $kIPMNilUserProc -15137)
(defconstant $kIPMBadCatSize -15138)
(defconstant $kIPMIncompleteMsg -15139)
(defconstant $kIPMNoResponsibleTunnel -15140)
(defconstant $kIPMAccessDenied -15141)
(defconstant $kIPMReplyParamUnderrun -15142);  Too few reply parameters 
(defconstant $kIPMReplyParamOverrun -15143);  Too many reply parameters 
(defconstant $kIPMRequestParamUnderrun -15144);  Too few request parameters 
(defconstant $kIPMOutOfSync -15145);  Protocol sync. error 
(defconstant $kIPMNoAttrsFound -15146);  couldn't find any attrs in lookup 
(defconstant $kIPMWrongAttrTag -15147);  wrong attr tag in adas lookup 
(defconstant $kIPMNullCID -15148);  null cid in enumerate 
(defconstant $kIPMBadMailSlotAttrVal -15149);  invalid mailslot attr value 

; $ENDC                         ;  UsingOCEErrors 

; $IFC NOT UsingIncludes

; $ENDC

(export '($KIPMBADMAILSLOTATTRVAL $KIPMNULLCID $KIPMWRONGATTRTAG
          $KIPMNOATTRSFOUND $KIPMOUTOFSYNC $KIPMREQUESTPARAMUNDERRUN
          $KIPMREPLYPARAMOVERRUN $KIPMREPLYPARAMUNDERRUN $KIPMACCESSDENIED
          $KIPMNORESPONSIBLETUNNEL $KIPMINCOMPLETEMSG $KIPMBADCATSIZE
          $KIPMNILUSERPROC $KIPMNOMORESESSIONS $KIPMINVALIDUSER
          $KIPMCOULDNOTREADINFOREPLY $KIPMNOMOREFILTERS $KIPMLOGINUNKNOWN
          $KIPMUNSUPPORTEDLOGIN $KIPMUNKNOWNUAM $KIPMLOOKUPATTRTOOBIG
          $KIPMNOMORESERVICES $KIPMNOTSAMEBIN $KIPMQBUSY $KIPMEOELT
          $KIPMEOCATENTRY $KIPMBINOUTOFSPACE $KIPMELTNOTFOUND $KIPMQOUTOFSPACE
          $KIPMEOQ $KIPMCONTEXTISCLOSING $KIPMBADCONTEXT
          $KIPMELTCLOSEDNOTDELETED $KIPMELTBUSY $KIPMMGRINTERNALERR
          $KIPMBINNEEDSCONVERSION $KIPMENDOFBIN $KIPMBADQNAME $KIPMCORRUPTEDBIN
          $KIPMBINBUSY $KIPMPORTCLOSED $KIPMSTREAMERR $KIPMBLKNOTFOUND
          $KIPMATTRNOTINHDR $KIPMINVALIDFILTER $KIPMNORECIPIENTSYET
          $KIPMINVALIDSENDER $KIPMCACHEFILLERROR $KIPMBLOCKISNOTNESTEDMSG
          $KIPMABORTOFNESTEDMSG $KIPMCORRUPTDATASTRUCTURES $KIPMA1HDRCORRUPT
          $KIPMNESTEDMSGOPENED $KIPMNOTINABLOCK $KIPMMSGTYPERESERVED
          $KIPMUPDATECATFAILED $KIPMINVALIDOFFSET $KIPMINVALIDPROCHINT
          $KIPMINVALIDMSGTYPE $KIPMCANTCREATEIPMCATENTRY $KMAILBADSTATE
          $KMAILCANNOTLKUPSERVERSLOTS $KMAILBADMSAM $KMAILBADCONFIG
          $KMAILSETFAILED $KMAILBADLTRINFO $KMAILNOSUCHSLOT
          $KMAILMALFORMEDCONTENT $KMAILBADSLOTINFO $KMAILMSAMSUSPENDED
          $KMAILSLOTSUSPENDED $KMAILCANCELLED $KMAILNOMSAMERR $KMAILTOOMANYERR
          $KMAILLENGTHERR $KMAILIGNOREDERR $KMAILGWYDEAD
          $KMAILTOOMANYTAGSPERLETTER $KMAILCANNOTWRITEMAILCAT
          $KMAILMISSINGMAILCAT $KMAILLTRNOTOPEN $KMAILNOTASLOTINQ
          $KMAILINVALIDPOSTITVERSION $KMAILINVALIDREQUEST
          $KMAILBADENCLLENGTHERR $KMAILHDRATTRMISSING $KMAILATTRNOTINHDR
          $KMAILINVALIDSEQNUM $KMAILINVALIDORDER $KDETPROPERTYBUSY
          $KDETINVALIDCALLBACK $KDETINVALIDREQFUNCTION
          $KDETCOULDNOTFINDCUSTOMVIEW $KDETCOULDNOTFINDMENUITEM
          $KDETCOULDNOTREMOVEMENUITEM $KDETCOULDNOTADDMENUITEM $KDETNOSUCHVIEW
          $KDETINFOPAGENOTOPEN $KDETUNABLETOACCESSPROPERTY $KDETINVALIDDSSPEC
          $KDETREQUESTEDTYPEUNAVAILABLE $KDETUNABLETOGETCOMMANDITEMSPEC
          $KDETINVALIDCOMMANDITEMNUMBER $KDETTARGETNOTANASPECT
          $KDETINVALIDTARGET $KDETUNKNOWNTARGETSELECTOR
          $KDETINVALIDTARGETDSSPEC $KDETINVALIDTARGETFROMNONASPECT
          $KDETINVALIDTARGETITEMNUMBER $KDETINVALIDTARGETASPECTNAME
          $KSIGNOSIGNATURE $KSIGSIGNERNOTVALIDERR $KSIGCONVERSIONERR
          $KSIGNODIGESTERR $KSIGCONTEXTPREPAREERR $KSIGTOOLBOXNOTPRESENTERR
          $KSIGINTERNALSERR $KSIGPASSWORDERR $KSIGSIGNERERR $KSIGINDEXERR
          $KSIGINVALIDCREDENTIALERR $KSIGVERIFYFAILEDERR
          $KSIGCERTIFICATEQUERYDENIED $KSIGOPERATIONINCOMPATIBLEERR
          $KSDPPERSONALDIRECTORYREPAIRFAILED $KSDPNOSELECTION
          $KSDPTOOMANYLOGINATTEMPTS $KSDPNOSEARCHTEXT $KSMPTOOMANYENCLOSURES
          $KSMPTOOMANYPAGES $KSMPPARAMCOUNTERR $KSMPSUBJECTTOOBIG
          $KSMPINVALIDADDRESSSTRING $KSMPILLEGALSENDFORMATS
          $KSMPADDRESSALREADYINLIST $KSMPRECORDDOESNOTCONTAINADDRESS
          $KSMPCOMPONENTISALREADYTARGET $KSMPMAILERALREADYNOTTARGET
          $KSMPILLEGALCOMPONENT $KSMPMAILERALREADYEXPANDEDORCONTRACTED
          $KSMPMAILERCANNOTEXPANDORCONTRACT $KSMPILLEGALFORDRAFTLETTER
          $KSMPCANNOTSENDRECEIVEDLETTER $KSMPNOMATCHINGBEGIN
          $KSMPMAILERUNEDITABLE $KSMPMAILERALREADYINWINDOW $KSMPNOSUCHADDRESS
          $KSMPNOMAILERINWINDOW $KSMPCOMMANDDISABLED $KSMPFINDERNOTRUNNING
          $KSMPHASOPENATTACHMENTS $KSMPNONEXTLETTER $KSMPMAILBOXNOTFOUND
          $KSMPSHOULDNOTADDCONTENT $KSMPMAILERNOTINITIALIZED
          $KSMPCOPYINPROGRESS $KSMPNOTENOUGHMEMORYFORALLRECIPS
          $KOCEDIRECTORYCORRUPT $KOCERLISDONTMATCH $KOCENOSUCHICON
          $KOCEMISCERROR $KOCENOSUCHATTRIBUTETYPE $KOCENODUPALLOWED
          $KOCEMOREATTRVALUE $KOCEBADSTARTINGATTRIBUTE $KOCEBADSTARTINGRECORD
          $KOCELENGTHERROR $KOCEDSAMRECORDEXISTS $KOCEDSAMNOTINSTANTIATED
          $KOCEDSAMRECORDNOTFOUND $KOCEOCESETUPREQUIRED $KOCEABORTED
          $KOCEABORTNOTSUPPORTEDFORTHISCALL $KOCEDIRECTORYNOTFOUNDERR
          $KOCEDIRLISTFULLERR $KOCEDSAMINSTALLERR $KOCEPABNOTOPEN
          $KOCEOPERATIONNOTSUPPORTED $KOCESTREAMCREATIONERR $KOCEREFNUMBAD
          $KOCEMOREDATA $KOCETYPEEXISTS $KOCEATTRIBUTEVALUETOOBIG
          $KOCENOSUCHPSEUDONYM $KOCENOSUCHATTRIBUTEVALUE $KOCENOSUCHRECORD
          $KOCEBADRECORDID $KOCEDNODEUNAVAILABLE $KOCENOSUCHDNODE
          $KOCEBOGUSARGS $KOCETARGETDIRECTORYINACCESSIBLE $KOCEDATABASEFULL
          $KOCETOOBUSY $KOCENOTLOCAL $KOCEAUTHENTICATIONTROUBLE
          $KOCENOASDSPWORKSPACE $KOCEAMBIGUOUSMATCHES $KOCEOPERATIONDENIED
          $KOCEUNKNOWNID $KOCENOMOREIDS $KOCENOTLOCALIDENTITY
          $KOCEDIRECTORYIDENTITYSETUPDOESNOTEXIST
          $KOCEDIRECTORYIDENTITYSETUPEXISTS $KOCELOCALIDENTITYSETUPEXISTS
          $KOCELOCALAUTHENTICATIONFAIL $KOCELOCALIDENTITYDOESNOTEXIST
          $KOCEBADENCRYPTIONMETHOD $KOCEINITIATORKEYPROBLEM
          $KOCEWRONGIDENTITYORKEY $KOCEUNDESIRABLEKEY $KOCEMALFORMEDKEY
          $KOCEKEYALREADYREGISTERED $KOCEAGENTKEYNOTFOUND
          $KOCERECIPIENTKEYNOTFOUND $KOCEPRINCIPALKEYNOTFOUND $KOCENOKEYFOUND
          $KOCEDISALLOWEDRECIPIENT $KOCEPROXYEXPIRED $KOCEPROXYIMMATURE
          $KOCECREDENTIALSEXPIRED $KOCECREDENTIALSIMMATURE
          $KOCECREDENTIALSPROBLEM $KOCEUNSUPPORTEDCREDENTIALSVERSION
          $KOCEACCESSRIGHTSINSUFFICIENT $KOCEWRITEACCESSDENIED
          $KOCEREADACCESSDENIED $KOCEPARAMERR $KOCEMOREDISKSPACENEEDED
          $KOCESERVERINACTIVE $KOCEREQUIREDSERVICESNOTAVAILABLE
          $KOCEINVALIDCONFIGURATION $KOCEHASPENDINGMSGS $KOCEREFISCLOSING
          $KOCEINVALIDINDEX $KOCEINVALIDRECIPIENT $KOCECONNECTIONCLOSED
          $KOCECONNECTIONERR $KOCEDOESNTEXIST $KOCEALREADYEXISTS
          $KOCENOTAUTHENTICATED $KOCENOTIMPLEMENTED $KOCENOTANOWNER
          $KOCEINTERNALERR $KOCESYNCASYNCERR $KOCEVERSIONERR
          $KOCEBUFFERTOOSMALL $KOCEINVALIDREF $KOCEINVALIDCOMMAND
          $KOCETOOLBOXNOTOPEN))
(provide-interface 'OCEErrors)