
(in-package :TRAPS)             ; ***********************************************************
; 
; Created: Monday, November 8, 1993 11:59AM
;  OCEStandardDirectory.p
;  Pascal Interface to the Macintosh Libraries
; 
;   Copyright Apple Computer, Inc. 1990-1993
;   All rights reserved
; 
; ***********************************************************

; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes:= 0
; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED UsingOCEStandardDirectory
; $SETC UsingOCEStandardDirectory:= 1

; $I+
; $SETC OCEStandardDirectoryIncludes:= UsingIncludes
; $SETC UsingIncludes:= 1

; $IFC UNDEFINED UsingOCE
; $I OCE.p
; $ENDC

; $IFC UNDEFINED UsingOCEAuthDir
; $I OCEAuthDir.p
; $ENDC

; $IFC UNDEFINED UsingTypes

(require-interface 'TYPES)      ; $I $$Shell(PInterfaces)Types.p
; $ENDC

; $IFC UNDEFINED UsingWindows

(require-interface 'WINDOWS)    ; $I $$Shell(PInterfaces)Windows.p
; $ENDC

; $IFC UNDEFINED UsingIcons

(require-interface 'ICONS)      ; $I $$Shell(PInterfaces)Icons.p
; $ENDC

; $SETC UsingIncludes:= OCEStandardDirectoryIncludes

;  CollabPack Trap Selectors 

(defconstant $kSDPNewPanel 100)
(defconstant $kSDPGetNewPanel 101)
(defconstant $kSDPDisposePanel 102)
(defconstant $kSDPHidePanel 103)
(defconstant $kSDPShowPanel 104)
(defconstant $kSDPEnablePanel 105)
(defconstant $kSDPUpdatePanel 106)
(defconstant $kSDPMovePanel 107)
(defconstant $kSDPSizePanel 108)
(defconstant $kSDPOpenSelectedItem 109)
(defconstant $kSDPGetPanelSelectionState 110)
(defconstant $kSDPGetPanelSelection 111)
(defconstant $kSDPSetPath 112)
(defconstant $kSDPPanelEvent 113)
(defconstant $kSDPGetPanelSelectionSize 114)
(defconstant $kSDPSetIdentity 115)
(defconstant $kSDPSelectString 116)
(defconstant $kSDPGetPathLength 117)
(defconstant $kSDPGetPath 118)
(defconstant $kSDPSetFocus 119)
(defconstant $kSDPSetPanelBalloonHelp 120)
(defconstant $kSDPInstallPanelBusyProc 121)

(defconstant $kSDPPromptForID 904)

(defconstant $kSDPNewFindPanel 2300)
(defconstant $kSDPDisposeFindPanel 2301)
(defconstant $kSDPStartFind 2302)
(defconstant $kSDPStopFind 2303)
(defconstant $kSDPFindPanelEvent 2304)
(defconstant $kSDPDrawFindPanel 2305)
(defconstant $kSDPShowFindPanel 2306)
(defconstant $kSDPHideFindPanel 2307)
(defconstant $kSDPMoveFindPanel 2308)
(defconstant $kSDPEnableFindPanel 2309)
(defconstant $kSDPSetFindPanelFocus 2310)
(defconstant $kSDPGetFindPanelState 2311)
(defconstant $kSDPGetFindPanelSelectionSize 2312)
(defconstant $kSDPGetFindPanelSelection 2313)
(defconstant $kSDPSetFindPanelBalloonHelp 2314)
(defconstant $kSDPSetFindIdentity 2315)
(defconstant $kSDPInstallFindPanelBusyProc 2316)

(defconstant $kSDPGetIconByType 1024)
(defconstant $kSDPGetDSSpecIcon 1025)
(defconstant $kSDPGetCategories 1026)
(defconstant $kSDPGetCategoryTypes 1027)

(defconstant $kSDPResolveAliasFile 3700)
(defconstant $kSDPResolveAliasDSSpec 3701)

(defconstant $kSDPRepairPersonalDirectory 6700)

;  Collaboration Package Gestalts. 

(defconstant $gestaltSDPStandardDirectoryVersion :|sdvr|)
(defconstant $gestaltSDPFindVersion :|dfnd|)
(defconstant $gestaltSDPPromptVersion :|prpv|)

; $IFC UNDEFINED svLarge1Bit
;   Selector mask values  
;  This is temporary. It will eventually appear in Icons.h 

(def-mactype :ICONSELECTORVALUE (find-mactype :SIGNED-LONG))

(defconstant $svLarge1Bit #X1)
(defconstant $svLarge4Bit #X2)
(defconstant $svLarge8Bit #X4)
(defconstant $svSmall1Bit #X100)
(defconstant $svSmall4Bit #X200)
(defconstant $svSmall8Bit #X400)
(defconstant $svMini1Bit #X10000)
(defconstant $svMini4Bit #X20000)
(defconstant $svMini8Bit #X40000)
(defconstant $svAllLargeData #XFF)
(defconstant $svAllSmallData #XFF00)
(defconstant $svAllMiniData #XFF0000)
(defconstant $svAll1BitData (+ #$SVLARGE1BIT (+ #$SVSMALL1BIT #$SVMINI1BIT)))
(defconstant $svAll4BitData (+ #$SVLARGE4BIT (+ #$SVSMALL4BIT #$SVMINI4BIT)))
(defconstant $svAll8BitData (+ #$SVLARGE8BIT (+ #$SVSMALL8BIT #$SVMINI8BIT)))
(defconstant $svAllAvailableData #XFFFFFFFF)
; $ENDC

;  generic icon suites 

(defconstant $genericDirectoryIconResource -16721);  icl8, icl4, ICN#, ics#, ics4, ics8, sicn  
(defconstant $genericLockedDirectoryIconResource -16716);  icl8, icl4, ICN#, ics#, ics4, ics8, sicn  
(defconstant $genericRecordIconResource -16722);  icl8, icl4, ICN#, ics#, ics4, ics8, sicn  
(defconstant $genericAttributeIconResource -16723);  icl8, icl4, ICN#, ics#, ics4, ics8, sicn  
(defconstant $genericTemplateIconResource -16746);  icl8, icl4, ICN#, ics#, ics4, ics8 

;  standard icon suites 

(defconstant $directoryFolderIconResource -16720);  icl8, icl4, ICN#, ics#, ics4, ics8, sicn  
(defconstant $lockedDirectoryFolderIconResource -16719);  icl8, icl4, ICN#, ics#, ics4, ics8, sicn  
(defconstant $personalDirectoryIconResource -16718);  icl8, icl4, ICN#, ics#, ics4, ics8, sicn  
(defconstant $directoriesIconResource -16717);  icl8, icl4, ICN#, ics#, ics4, ics8, sicn  
(defconstant $preferredPersonalDirectoryIconResource -16724);  icl8, icl4, ICN#, ics#, ics4, ics8, sicn  

;  icon IDs for spinning arrows 
(defconstant $kFirstSpinnerIcon -16745)
(defconstant $kLastSpinnerIcon -16738)

;  resource types 
(defconstant $kSDPPanelResourceType :|panl|)
(defconstant $kSDPFindPanelResourceType :|find|)

;  Standard FindPanel resource 
(defconstant $kStandardFindLayout -16700)

;  Values of SDPMatchWith 
(defconstant $kSDPMatchAll 0)
(defconstant $kSDPExactMatch 256)
(defconstant $kSDPBeginsWith 512)
(defconstant $kSDPEndingWith 1024)
(defconstant $kSDPContaining 2048)

(def-mactype :SDPMATCHWITH (find-mactype :SIGNED-INTEGER))

;  Prompt For Identity structures 

(defconstant $kSDPGuestBit 0)
(defconstant $kSDPSpecificIdentityBit 1)
(defconstant $kSDPLocalIdentityBit 2)

;  Values of SDPIdentityKind 
(defconstant $kSDPGuestMask #X1); 1<<kSDPGuestBit
(defconstant $kSDPSpecificIdentityMask #X2); 1<<kSDPSpecificIdentityBit
(defconstant $kSDPLocalIdentityMask #X4); 1<<kSDPLocalIdentityBit

(def-mactype :SDPIDENTITYKIND (find-mactype :SIGNED-INTEGER))

(defconstant $kSDPSuggestionOnly 0)
(defconstant $kSDPRestrictToDirectory 1)
(defconstant $kSDPRestrictToRecord 2)

(def-mactype :SDPLOGINFILTERKIND (find-mactype :SIGNED-INTEGER))

;  Panel Structures 

; 
; While the panel is in operation, four selection states may exist.
; 	1) kSDPNothingSelected means nothing is selected.
; 	2) kContainSelected means a volume, folder, directory, dnode, or PAB is selected.
; 	3) kSDPLockedContainerSelected means one of the above, but no access privledges.
; 	4) kSDPRecordSelected means that a record is currently selected.
; 

;  Values of SDPSelectionState 
(defconstant $kSDPNothingSelected 0)
(defconstant $kSDPLockedContainerSelected 1)
(defconstant $kSDPContainerSelected 2)
(defconstant $kSDPRecordSelected 3)
(defconstant $kSDPRecordAliasSelected 4)
(defconstant $kSDPContainerAliasSelected 5)

(def-mactype :SDPSELECTIONSTATE (find-mactype :SIGNED-INTEGER))

; 
; This type informs the caller of the action the user took, either as the result
; of an event (as returned by SDPPanelEvent) or when SDPOpenSelectedItem is called.
; 
; kSDPProcessed means that the event (or call to SDPOpenSelectedItem) resulted in no
; state change.
; 
; kSDPSelectedAnItem indicates that the user wants to select the currently-hilited
; record. This is returned, for example, when a user double-clicks on a record.
; 
; kSDPChangedSelection implies that the user clicked on a new item (which may mean
; that no item is selected).
; 

;  Values of SDPPanelState 
(defconstant $kSDPProcessed 0)
(defconstant $kSDPSelectedAnItem 1)
(defconstant $kSDPChangedSelection 2)

(def-mactype :SDPPANELSTATE (find-mactype :SIGNED-INTEGER))

; 
; Your application may read any of the fields in a SDPPanelRecord, but it should
; use the appropriate routines to make changes to the records with the exception
; of the refCon field which your application may read or write at will.  Private
; information follows the SDPPanelRecord, so the handle must not be re-sized.
; 

(defrecord SDPPanelRecord 
   (bounds :RECT)
   (visible :BOOLEAN)
   (enabled :BOOLEAN)
   (focused :BOOLEAN)
; padByte: Byte;
   (identity :SIGNED-LONG)
   (refCon :SIGNED-LONG)
   (listRect :RECT)
   (popupRect :RECT)
   (numberOfRows :SIGNED-INTEGER)
   (rowHeight :SIGNED-INTEGER)
   (pabMode :BOOLEAN)
   )

(def-mactype :SDPPANELPTR (find-mactype :POINTER))
(def-mactype :SDPPANELHANDLE (find-mactype :HANDLE))

(def-mactype :PANELBUSYPROC (find-mactype :POINTER))
;  PROCEDURE PanelBusyProc(Panel: SDPPanelHandle; busy: BOOLEAN); 

;  Find Panel Structures 

(defconstant $kSDPItemIsSelectedBit 0)
(defconstant $kSDPFindTextExistsBit 1)
;  Values of SDPFindPanelState 
(defconstant $kSDPItemIsSelectedMask #X1); 1<<kSDPItemIsSelectedBit
(defconstant $kSDPFindTextExistsMask #X2); 1<<kSDPFindTextExistsBit

(def-mactype :SDPFINDPANELSTATE (find-mactype :SIGNED-INTEGER))

;  Values of SDPFindPanelFocus 

(defconstant $kSDPFindPanelNoFocus 0)
(defconstant $kSDPFindPanelListHasFocus 1)
(defconstant $kSDPFindPanelTextHasFocus 2)

(def-mactype :SDPFINDPANELFOCUS (find-mactype :SIGNED-INTEGER))

(defrecord SDPFindPanelRecord 
   (upperLeft :POINT)
   (visible :BOOLEAN)
   (enabled :BOOLEAN)
   (nowFinding :BOOLEAN)
; padByte: Byte;
   (currentFocus :SIGNED-INTEGER)
   (identity :SIGNED-LONG)
   (simultaneousSearchCount :SIGNED-INTEGER)
   (refCon :SIGNED-LONG)
   )

(def-mactype :SDPFINDPANELPTR (find-mactype :POINTER))
(def-mactype :SDPFINDPANELHANDLE (find-mactype :HANDLE))

;  Values of SDPFindPanelResult 
(defconstant $kSDPSelectedAFindItem 0)
(defconstant $kSDPFindSelectionChanged 1)
(defconstant $kSDPFindCompleted 2)
(defconstant $kSDPTextStateChanged 3)
(defconstant $kSDPFocusChanged 4)
(defconstant $kSDPSelectionAndFocusChanged 5)
(defconstant $kSDPMenuChanged 6)
(defconstant $kSDPSelectionAndMenuChanged 7)
(defconstant $kSDPProcessedFind 8)

(def-mactype :SDPFINDPANELRESULT (find-mactype :SIGNED-INTEGER))

(def-mactype :PACKEDRSTRINGLISTHANDLE (find-mactype :HANDLE))

(def-mactype :PACKEDDSSPECHANDLE (find-mactype :HANDLE))

(def-mactype :FINDPANELBUSYPROC (find-mactype :POINTER))
; PROCEDURE FindPanelBusyProc(findPanel: SDPFindPanelHandle; busy: BOOLEAN); 

;  Prompt For Identity Routines 


(deftrap _sdppromptforid ((id (:pointer :signed-long)) (guestprompt (:pointer (:string 255))) (specificidprompt (:pointer (:string 255))) (localidprompt (:pointer (:string 255))) (recordtype (:pointer :rstring)) (permittedkinds :signed-integer) (selectedkind (:pointer :signed-integer)) (loginfilter (:pointer :recordid)) (filterkind :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 16 16) 904) id guestprompt specificidprompt localidprompt recordtype permittedkinds selectedkind loginfilter filterkind))

; 
; SDPNewPanel creates a new panel. You supply the window in which the panel
; is to live, the bounds for the panel (which includes both the menu and the list),
; whether or not the panel is to be initially visible, the initial RLI (nil for
; directories and volumes), the types of records that will be shown (only a single
; (non-nil) type which may contain wildcards), the identity by which to browse
; (for access control reasons), and a refCon which is  available to the caller.
; 

(deftrap _sdpnewpanel ((newpanel (:pointer (:handle :sdppanelrecord))) (window (:pointer :grafport)) (bounds :rect) (visible :boolean) (enabled :boolean) (initialrli (:pointer :packedrli)) (typeslist (:handle :rstring)) (typecount :signed-long) (identity :signed-long) (enumflags :signed-long) (matchtypehow :signed-integer) (refcon :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 21 16) 100) newpanel window bounds visible enabled initialrli typeslist typecount identity enumflags matchtypehow refcon))

; 
; SDPSetIdentity Sets the identity used for browsing.
; 

(deftrap _sdpsetidentity ((panel (:handle :sdppanelrecord)) (identity :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 115) panel identity))

; 
; SDPGetNewPanel is similar to SDPNewPanel above, except it takes a resource id of a
; 'panl' resource.
; 

(deftrap _sdpgetnewpanel ((newpanel (:pointer (:handle :sdppanelrecord))) (resourceid :signed-integer) (window (:pointer :grafport)) (initialrli (:pointer :packedrli)) (identity :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 9 16) 101) newpanel resourceid window initialrli identity))

; 
; Call this when you're completely done with a panel. It deallocates all of the
; associated data structures.
; 

(deftrap _sdpdisposepanel ((panel (:handle :sdppanelrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 102) panel))

; 
; If the panel is visible, it makes it invisible by hiding the menu, turning off
; drawing of the list, and erasing and  invaling the list's rectangle.
; 

(deftrap _sdphidepanel ((panel (:handle :sdppanelrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 103) panel))

;  If the panel is invisible, it makes it visible and draws it. 


(deftrap _sdpshowpanel ((panel (:handle :sdppanelrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 104) panel))

;  Disables the list and menu so that it won't accept any commands. 


(deftrap _sdpenablepanel ((panel (:handle :sdppanelrecord)) (enable :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 3 16) 105) panel enable))

; 
; Move the upper-left-hand corner of the panel to (h, v), given in local coordinates of
; the panel's window.
; 

(deftrap _sdpmovepanel ((panel (:handle :sdppanelrecord)) (h :signed-integer) (v :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 107) panel h v))

; 
; Resizes the panel to have the given width and height (keeping the upper-left-hand
; corner in a fixed position).
; 

(deftrap _sdpsizepanel ((panel (:handle :sdppanelrecord)) (width :signed-integer) (height :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 108) panel width height))

; 
; This routine simulates a double-click on the selected item (if there is no selected
; item, then it does nothing), and it returns the result of that "double-click" via the
; whatHappened parameter. If a container is selected, then that container will be
; opened and kMovedDownTheHierarchy is returned. If, however, the user is at the lowest
; level in the hierarchy, then kSDPSelectedAnItem is returned.
; 

(deftrap _sdpopenselecteditem ((panel (:handle :sdppanelrecord)) (whathappened (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 109) panel whathappened))

; 
; Returns whether a record is selected, something else is selected, or nothing is
; selected.
; 

(deftrap _sdpgetpanelselectionstate ((panel (:handle :sdppanelrecord)) (itsstate (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 110) panel itsstate))

; 
; Returns the size of the currently-selected DSSpec, or zero if a record is
; not selected.  It is safe to do a NewPtr (SDPGetPanelSelectionSize (...))
; 

(deftrap _sdpgetpanelselectionsize ((panel (:handle :sdppanelrecord)) (dsspecsize (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 114) panel dsspecsize))

; 
; Returns the currently-selected DSSpec, or a zero-lengthed
; DSSpec if a record is not selected. It is assumed that the selection
; buffer allocated is large enough.
; 

(deftrap _sdpgetpanelselection ((panel (:handle :sdppanelrecord)) (selection (:pointer :packeddsspec)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 111) panel selection))

; 
; Forces browsing to the specified RLI. If prli is the current RLI, then it does
; nothing.
; 

(deftrap _sdpsetpath ((panel (:handle :sdppanelrecord)) (prli (:pointer :packedrli)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 112) panel prli))

; 
; This is the main driver for the panel.  You should pass all events to SDPPanelEvent
; including NULL events.  If you have more than 1 panel, you will need to
; call SDPPanelEvent for each panel.  NOTE:  For Update Events you will also need to call
; SDPUpdatePanel as described below.
; 

(deftrap _sdppanelevent ((panel (:handle :sdppanelrecord)) (theevent :eventrecord) (whathappened (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 6 16) 113) panel theevent whathappened))

; 
; SDPUpdatePanel should be called in response to an update event.  Generally you will
; have first called BeginUpdate, and pass the windows visRgn as theRgn.  If NULL
; is passed for theRgn the entire panel is re-drawn.  NOTE:  Drawing is not cliped to
; theRgn, if this is desired, you must first call SetClip.
; 

(deftrap _sdpupdatepanel ((panel (:handle :sdppanelrecord)) (thergn (:handle :region)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 106) panel thergn))

; 
; SDPSelectString scrolls and selects the closest matching string at the current
; level.  This is the same behavior as if the user typed in the given string.
; 

(deftrap _sdpselectstring ((panel (:handle :sdppanelrecord)) (name (:pointer :rstring)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 116) panel name))

; 
; SDPGetPathLength returns the length in bytes required to hold the current path name
; in RLI format.  This corresponds to the path name in the popup menu.
; 

(deftrap _sdpgetpathlength ((panel (:handle :sdppanelrecord)) (pathnamelength (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 117) panel pathnamelength))

;  SDPGetPath returns the current rli. 

(deftrap _sdpgetpath ((panel (:handle :sdppanelrecord)) (prli (:pointer :packedrli)) (dsrefnum (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 6 16) 118) panel prli dsrefnum))

; 
; SDPSetFocus will draw the focus rectangle or erase the focus rectangle depending upon
; the focus boolean.
; 

(deftrap _sdpsetfocus ((panel (:handle :sdppanelrecord)) (focus :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 3 16) 119) panel focus))

; 
; SDPSetPanelBalloonHelp allows clients to specify a STR# resource id to use for
; balloon help.  Balloon help is unavailable until this call is made.
; 

(deftrap _sdpsetpanelballoonhelp ((panel (:handle :sdppanelrecord)) (balloonhelpid :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 3 16) 120) panel balloonhelpid))

; 
; SDPInstallPanelBusyProc allows clients to install a CB that will be called while
; the panel is aynchronously busy.
; 

(deftrap _sdpinstallpanelbusyproc ((panel (:handle :sdppanelrecord)) (busyproc :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 121) panel busyproc))


(deftrap _sdpnewfindpanel ((newpanel (:pointer (:handle :sdpfindpanelrecord))) (window (:pointer :grafport)) (upperleft :point) (layoutresourceid :signed-integer) (visible :boolean) (enabled :boolean) (typeslist (:handle :rstring)) (typecount :signed-long) (matchtypehow :signed-integer) (identity :signed-long) (simultaneoussearchcount :signed-integer) (initialfocus :signed-integer) (refcon :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 20 16) 2300) newpanel window upperleft layoutresourceid visible enabled typeslist typecount matchtypehow identity simultaneoussearchcount initialfocus refcon))


(deftrap _sdpdisposefindpanel ((findpanel (:handle :sdpfindpanelrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 2301) findpanel))


(deftrap _sdpstartfind ((findpanel (:handle :sdpfindpanelrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 2302) findpanel))


(deftrap _sdpstopfind ((findpanel (:handle :sdpfindpanelrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 2303) findpanel))


(deftrap _sdpfindpanelevent ((findpanel (:handle :sdpfindpanelrecord)) (event :eventrecord) (whathappened (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 6 16) 2304) findpanel event whathappened))


(deftrap _sdpupdatefindpanel ((findpanel (:handle :sdpfindpanelrecord)) (thergn (:handle :region)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 2305) findpanel thergn))


(deftrap _sdpshowfindpanel ((findpanel (:handle :sdpfindpanelrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 2306) findpanel))


(deftrap _sdphidefindpanel ((findpanel (:handle :sdpfindpanelrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 2 16) 2307) findpanel))


(deftrap _sdpmovefindpanel ((findpanel (:handle :sdpfindpanelrecord)) (h :signed-integer) (v :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 2308) findpanel h v))


(deftrap _sdpenablefindpanel ((findpanel (:handle :sdpfindpanelrecord)) (enabled :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 3 16) 2309) findpanel enabled))


(deftrap _sdpsetfindpanelfocus ((findpanel (:handle :sdpfindpanelrecord)) (newfocus :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 3 16) 2310) findpanel newfocus))


(deftrap _sdpgetfindpanelstate ((findpanel (:handle :sdpfindpanelrecord)) (itsstate (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 2311) findpanel itsstate))


(deftrap _sdpgetfindpanelselectionsize ((findpanel (:handle :sdpfindpanelrecord)) (size (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 2312) findpanel size))


(deftrap _sdpgetfindpanelselection ((findpanel (:handle :sdpfindpanelrecord)) (selection (:pointer :packeddsspec)))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 2313) findpanel selection))


(deftrap _sdpsetfindpanelballoonhelp ((findpanel (:handle :sdpfindpanelrecord)) (balloonhelpid :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 3 16) 2314) findpanel balloonhelpid))


(deftrap _sdpsetfindidentity ((findpanel (:handle :sdpfindpanelrecord)) (identity :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 2315) findpanel identity))


(deftrap _sdpinstallfindpanelbusyproc ((findpanel (:handle :sdpfindpanelrecord)) (busyproc :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 4 16) 2316) findpanel busyproc))


(deftrap _sdpgeticonbytype ((recordtype (:pointer :rstring)) (whichicons :signed-long) (iconsuite (:pointer :handle)))
   (:stack :signed-integer)
   (:stack-trap #xAA5C :d0 1024 recordtype whichicons iconsuite))


(deftrap _sdpgetdsspecicon ((packeddsspec (:pointer :packeddsspec)) (whichicons :signed-long) (iconsuite (:pointer :handle)))
   (:stack :signed-integer)
   (:stack-trap #xAA5C :d0 1025 packeddsspec whichicons iconsuite))


(deftrap _sdpgetcategories ((catagories (:pointer (:handle :packedpathname))) (displaynames (:pointer (:handle :packedpathname))))
   (:stack :signed-integer)
   (:stack-trap #xAA5C :d0 1026 catagories displaynames))


(deftrap _sdpgetcategorytypes ((category (:pointer :rstring)) (types (:pointer (:handle :packedpathname))))
   (:stack :signed-integer)
   (:stack-trap #xAA5C :d0 1027 category types))


(deftrap _sdpresolvealiasfile ((filespec :fsspecptr) (resolveddsspec (:handle :packeddsspec)) (identity :signed-long) (maypromptuser :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 7 16) 3700) filespec resolveddsspec identity maypromptuser))


(deftrap _sdpresolvealiasdsspec ((thealiasdsspec (:handle :packeddsspec)) (identity :signed-long) (maypromptuser :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 5 16) 3701) thealiasdsspec identity maypromptuser))


(deftrap _sdprepairpersonaldirectory ((pd :fsspecptr) (showprogress :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA5D :d0 (+ (ash 3 16) 6700) pd showprogress))

; $ENDC                         ;  UsingOCEStandardDirectory 

; $IFC NOT UsingIncludes

; $ENDC

(export '($KSDPPROCESSEDFIND $KSDPSELECTIONANDMENUCHANGED $KSDPMENUCHANGED
          $KSDPSELECTIONANDFOCUSCHANGED $KSDPFOCUSCHANGED $KSDPTEXTSTATECHANGED
          $KSDPFINDCOMPLETED $KSDPFINDSELECTIONCHANGED $KSDPSELECTEDAFINDITEM
          $KSDPFINDPANELTEXTHASFOCUS $KSDPFINDPANELLISTHASFOCUS
          $KSDPFINDPANELNOFOCUS $KSDPFINDTEXTEXISTSMASK $KSDPITEMISSELECTEDMASK
          $KSDPFINDTEXTEXISTSBIT $KSDPITEMISSELECTEDBIT $KSDPCHANGEDSELECTION
          $KSDPSELECTEDANITEM $KSDPPROCESSED $KSDPCONTAINERALIASSELECTED
          $KSDPRECORDALIASSELECTED $KSDPRECORDSELECTED $KSDPCONTAINERSELECTED
          $KSDPLOCKEDCONTAINERSELECTED $KSDPNOTHINGSELECTED
          $KSDPRESTRICTTORECORD $KSDPRESTRICTTODIRECTORY $KSDPSUGGESTIONONLY
          $KSDPLOCALIDENTITYMASK $KSDPSPECIFICIDENTITYMASK $KSDPGUESTMASK
          $KSDPLOCALIDENTITYBIT $KSDPSPECIFICIDENTITYBIT $KSDPGUESTBIT
          $KSDPCONTAINING $KSDPENDINGWITH $KSDPBEGINSWITH $KSDPEXACTMATCH
          $KSDPMATCHALL $KSTANDARDFINDLAYOUT $KSDPFINDPANELRESOURCETYPE
          $KSDPPANELRESOURCETYPE $KLASTSPINNERICON $KFIRSTSPINNERICON
          $PREFERREDPERSONALDIRECTORYICONRESOURCE $DIRECTORIESICONRESOURCE
          $PERSONALDIRECTORYICONRESOURCE $LOCKEDDIRECTORYFOLDERICONRESOURCE
          $DIRECTORYFOLDERICONRESOURCE $GENERICTEMPLATEICONRESOURCE
          $GENERICATTRIBUTEICONRESOURCE $GENERICRECORDICONRESOURCE
          $GENERICLOCKEDDIRECTORYICONRESOURCE $GENERICDIRECTORYICONRESOURCE
          $SVALLAVAILABLEDATA $SVALL8BITDATA $SVALL4BITDATA $SVALL1BITDATA
          $SVALLMINIDATA $SVALLSMALLDATA $SVALLLARGEDATA $SVMINI8BIT
          $SVMINI4BIT $SVMINI1BIT $SVSMALL8BIT $SVSMALL4BIT $SVSMALL1BIT
          $SVLARGE8BIT $SVLARGE4BIT $SVLARGE1BIT $GESTALTSDPPROMPTVERSION
          $GESTALTSDPFINDVERSION $GESTALTSDPSTANDARDDIRECTORYVERSION
          $KSDPREPAIRPERSONALDIRECTORY $KSDPRESOLVEALIASDSSPEC
          $KSDPRESOLVEALIASFILE $KSDPGETCATEGORYTYPES $KSDPGETCATEGORIES
          $KSDPGETDSSPECICON $KSDPGETICONBYTYPE $KSDPINSTALLFINDPANELBUSYPROC
          $KSDPSETFINDIDENTITY $KSDPSETFINDPANELBALLOONHELP
          $KSDPGETFINDPANELSELECTION $KSDPGETFINDPANELSELECTIONSIZE
          $KSDPGETFINDPANELSTATE $KSDPSETFINDPANELFOCUS $KSDPENABLEFINDPANEL
          $KSDPMOVEFINDPANEL $KSDPHIDEFINDPANEL $KSDPSHOWFINDPANEL
          $KSDPDRAWFINDPANEL $KSDPFINDPANELEVENT $KSDPSTOPFIND $KSDPSTARTFIND
          $KSDPDISPOSEFINDPANEL $KSDPNEWFINDPANEL $KSDPPROMPTFORID
          $KSDPINSTALLPANELBUSYPROC $KSDPSETPANELBALLOONHELP $KSDPSETFOCUS
          $KSDPGETPATH $KSDPGETPATHLENGTH $KSDPSELECTSTRING $KSDPSETIDENTITY
          $KSDPGETPANELSELECTIONSIZE $KSDPPANELEVENT $KSDPSETPATH
          $KSDPGETPANELSELECTION $KSDPGETPANELSELECTIONSTATE
          $KSDPOPENSELECTEDITEM $KSDPSIZEPANEL $KSDPMOVEPANEL $KSDPUPDATEPANEL
          $KSDPENABLEPANEL $KSDPSHOWPANEL $KSDPHIDEPANEL $KSDPDISPOSEPANEL
          $KSDPGETNEWPANEL $KSDPNEWPANEL))
(provide-interface 'OCEStandardDirectory)