
(in-package :TRAPS)             ; ************************************************************
; 
; Created: Thursday, August 20, 1992 at 12:09 AM
;  MediaHandler.h
;  C Interface to the Macintosh Libraries
; 
; 
;  Copyright Apple Computer, Inc. 1991, 1992
;  All rights reserved
; 
; ************************************************************

; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED UsingMediaHandlers
; $SETC UsingMediaHandlers := 1

; $I+
; $SETC MediaHandlersIncludes := UsingIncludes
; $SETC UsingIncludes := 1
; $IFC UNDEFINED UsingMovies

(require-interface 'MOVIES)     ; $I $$Shell(PInterfaces)Movies.p
; $ENDC

; $SETC UsingIncludes := MediaHandlersIncludes

(defconstant $handlerHasSpatial #X1)
(defconstant $handlerCanClip #X2)
(defconstant $handlerCanMatte #X4)
(defconstant $handlerCanTransferMode #X8)
(defconstant $handlerNeedsBuffer #X10)
(defconstant $handlerNoIdle #X20)
(defconstant $handlerNoScheduler #X40)
(defconstant $handlerWantsTime #X80)
(defconstant $handlerCGrafPortOnly #X100)

(defconstant $mMustDraw #X8)
(defconstant $mAtEnd #X10)
(defconstant $mPreflightDraw #X20)

(defconstant $mDidDraw #X1)
(defconstant $mNeedsToDraw #X4)

(defrecord GetMovieCompleteParams 
   (version :SIGNED-INTEGER)
   (theMovie (:POINTER :MOVIERECORD))
   (theTrack (:POINTER :TRACKRECORD))
   (theMedia (:POINTER :MEDIARECORD))
   (movieScale :SIGNED-LONG)
   (mediaScale :SIGNED-LONG)
   (movieDuration :SIGNED-LONG)
   (trackDuration :SIGNED-LONG)
   (mediaDuration :SIGNED-LONG)
   (effectiveRate :SIGNED-LONG)
   (TimeBase (:POINTER :TIMEBASERECORD))
   (volume :SIGNED-INTEGER)
   (width :SIGNED-LONG)
   (height :SIGNED-LONG)
   (trackMovieMatrix :MATRIXRECORD)
   (moviePort (:POINTER :CGRAFPORT))
   (movieGD (:HANDLE :GDEVICE))
   (trackMatte (:HANDLE :PIXMAP))
   )

(defconstant $kMediaInitializeSelect #X501)
(defconstant $kMediaSetHandlerCapabilitiesSelect #X502)
(defconstant $kMediaIdleSelect #X503)
(defconstant $kMediaGetMediaInfoSelect #X504)
(defconstant $kMediaPutMediaInfoSelect #X505)
(defconstant $kMediaSetActiveSelect #X506)
(defconstant $kMediaSetRateSelect #X507)
(defconstant $kMediaGGetStatusSelect #X508)
(defconstant $kMediaTrackEditedSelect #X509)
(defconstant $kMediaSetMediaTimeScaleSelect #X50A)
(defconstant $kMediaSetMovieTimeScaleSelect #X50B)
(defconstant $kMediaSetGWorldSelect #X50C)
(defconstant $kMediaSetDimensionsSelect #X50D)
(defconstant $kMediaSetClipSelect #X50E)
(defconstant $kMediaSetMatrixSelect #X50F)
(defconstant $kMediaGetTrackOpaqueSelect #X510)
(defconstant $kMediaSetGraphicsModeSelect #X511)
(defconstant $kMediaGetGraphicsModeSelect #X512)
(defconstant $kMediaGSetVolumeSelect #X513)
(defconstant $kMediaSetSoundBalanceSelect #X514)
(defconstant $kMediaGetSoundBalanceSelect #X515)
(defconstant $kMediaGetNextBoundsChangeSelect #X516)
(defconstant $kMediaGetSrcRgnSelect #X517)
(defconstant $kMediaPrerollSelect #X518)


(deftrap _MEDIAINITIALIZE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (GMC (:POINTER :GETMOVIECOMPLETEPARAMS)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI GMC ((+ (ASH 4 16) 1281) :SIGNED-LONGINT)))

(deftrap _MEDIASETHANDLERCAPABILITIES ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (FLAGS :SIGNED-LONG) (FLAGSMASK :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI FLAGS FLAGSMASK ((+ (ASH 8 16) 1282) :SIGNED-LONGINT)))

(deftrap _MEDIAIDLE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (ATMEDIATIME :SIGNED-LONG) (FLAGSIN :SIGNED-LONG) (FLAGSOUT (:POINTER :SIGNED-LONG)) (MOVIETIME (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI ATMEDIATIME FLAGSIN FLAGSOUT MOVIETIME ((+ (ASH 16 16) 1283) :SIGNED-LONGINT)))

(deftrap _MEDIAGETMEDIAINFO ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (H :HANDLE))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI H ((+ (ASH 4 16) 1284) :SIGNED-LONGINT)))

(deftrap _MEDIAPUTMEDIAINFO ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (H :HANDLE))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI H ((+ (ASH 4 16) 1285) :SIGNED-LONGINT)))

(deftrap _MEDIASETACTIVE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (ENABLEMEDIA :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI ENABLEMEDIA ((+ (ASH 2 16) 1286) :SIGNED-LONGINT)))

(deftrap _MEDIASETRATE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (RATE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI RATE ((+ (ASH 4 16) 1287) :SIGNED-LONGINT)))

(deftrap _MEDIAGGETSTATUS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (STATUSERR (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI STATUSERR ((+ (ASH 4 16) 1288) :SIGNED-LONGINT)))

(deftrap _MEDIATRACKEDITED ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI ((+ (ASH 0 16) 1289) :SIGNED-LONGINT)))

(deftrap _MEDIASETMEDIATIMESCALE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (NEWTIMESCALE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI NEWTIMESCALE ((+ (ASH 4 16) 1290) :SIGNED-LONGINT)))

(deftrap _MEDIASETMOVIETIMESCALE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (NEWTIMESCALE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI NEWTIMESCALE ((+ (ASH 4 16) 1291) :SIGNED-LONGINT)))

(deftrap _MEDIASETGWORLD ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (APORT (:POINTER :CGRAFPORT)) (AGD (:HANDLE :GDEVICE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI APORT AGD ((+ (ASH 8 16) 1292) :SIGNED-LONGINT)))

(deftrap _MEDIASETDIMENSIONS ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (WIDTH :SIGNED-LONG) (HEIGHT :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI WIDTH HEIGHT ((+ (ASH 8 16) 1293) :SIGNED-LONGINT)))

(deftrap _MEDIASETCLIP ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (THECLIP (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI THECLIP ((+ (ASH 4 16) 1294) :SIGNED-LONGINT)))

(deftrap _MEDIASETMATRIX ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TRACKMOVIEMATRIX (:POINTER :MATRIXRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI TRACKMOVIEMATRIX ((+ (ASH 4 16) 1295) :SIGNED-LONGINT)))

(deftrap _MEDIAGETTRACKOPAQUE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TRACKISOPAQUE (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI TRACKISOPAQUE ((+ (ASH 4 16) 1296) :SIGNED-LONGINT)))

(deftrap _MEDIASETGRAPHICSMODE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (MODE :SIGNED-LONG) (OPCOLOR (:POINTER :RGBCOLOR)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI MODE OPCOLOR ((+ (ASH 8 16) 1297) :SIGNED-LONGINT)))

(deftrap _MEDIAGETGRAPHICSMODE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (MODE (:POINTER :SIGNED-LONG)) (OPCOLOR (:POINTER :RGBCOLOR)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI MODE OPCOLOR ((+ (ASH 8 16) 1298) :SIGNED-LONGINT)))

(deftrap _MEDIAGSETVOLUME ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (VOLUME :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI VOLUME ((+ (ASH 2 16) 1299) :SIGNED-LONGINT)))

(deftrap _MEDIASETSOUNDBALANCE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BALANCE :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BALANCE ((+ (ASH 2 16) 1300) :SIGNED-LONGINT)))

(deftrap _MEDIAGETSOUNDBALANCE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (BALANCE (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BALANCE ((+ (ASH 4 16) 1301) :SIGNED-LONGINT)))

(deftrap _MEDIAGETNEXTBOUNDSCHANGE ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (WHEN (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI WHEN ((+ (ASH 4 16) 1302) :SIGNED-LONGINT)))

(deftrap _MEDIAGETSRCRGN ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (RGN (:HANDLE :REGION)) (ATMEDIATIME :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI RGN ATMEDIATIME ((+ (ASH 8 16) 1303) :SIGNED-LONGINT)))

(deftrap _MEDIAPREROLL ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (TIME :SIGNED-LONG) (RATE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI TIME RATE ((+ (ASH 8 16) 1304) :SIGNED-LONGINT)))

(deftrap _MEDIASAMPLEDESCRIPTIONCHANGED ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (INDEX :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INDEX ((+ (ASH 4 16) 1305) :SIGNED-LONGINT)))

(deftrap _MEDIAHASCHARACTERISTIC ((CI (:POINTER :PRIVATECOMPONENTINSTANCERECORD)) (CHARACTERISTIC :OSTYPE) (HASIT (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CHARACTERISTIC HASIT ((+ (ASH 8 16) 1306) :SIGNED-LONGINT)))

; $ENDC                         ;  UsingMediaHandlers 

; $IFC NOT UsingIncludes

; $ENDC

(export '($KMEDIAPREROLLSELECT $KMEDIAGETSRCRGNSELECT
          $KMEDIAGETNEXTBOUNDSCHANGESELECT $KMEDIAGETSOUNDBALANCESELECT
          $KMEDIASETSOUNDBALANCESELECT $KMEDIAGSETVOLUMESELECT
          $KMEDIAGETGRAPHICSMODESELECT $KMEDIASETGRAPHICSMODESELECT
          $KMEDIAGETTRACKOPAQUESELECT $KMEDIASETMATRIXSELECT
          $KMEDIASETCLIPSELECT $KMEDIASETDIMENSIONSSELECT
          $KMEDIASETGWORLDSELECT $KMEDIASETMOVIETIMESCALESELECT
          $KMEDIASETMEDIATIMESCALESELECT $KMEDIATRACKEDITEDSELECT
          $KMEDIAGGETSTATUSSELECT $KMEDIASETRATESELECT $KMEDIASETACTIVESELECT
          $KMEDIAPUTMEDIAINFOSELECT $KMEDIAGETMEDIAINFOSELECT $KMEDIAIDLESELECT
          $KMEDIASETHANDLERCAPABILITIESSELECT $KMEDIAINITIALIZESELECT
          $MNEEDSTODRAW $MDIDDRAW $MPREFLIGHTDRAW $MATEND $MMUSTDRAW
          $HANDLERCGRAFPORTONLY $HANDLERWANTSTIME $HANDLERNOSCHEDULER
          $HANDLERNOIDLE $HANDLERNEEDSBUFFER $HANDLERCANTRANSFERMODE
          $HANDLERCANMATTE $HANDLERCANCLIP $HANDLERHASSPATIAL))
(provide-interface 'MediaHandlers)